var LOGFILE_NAME = "presence-simulator.log";
var l = new Logger(LOGFILE_NAME);

var constantAutoModeManualOff = 0;
var constantAutoModeOnlyHoliday = 1;
var constantAutoModeOnGehen = 2;
var constantAutoModeManualOn = 3;

var constantEmailOff = 0;
var constantEmailOn = 1;

var constantSendEmailHolidayStart = 0;
var constantSendEmailHolidayEnd = 1;
var constantSendEmailGehen = 2;
var constantSendEmailKommen = 3;
var constantSendEmailManualOn = 4;
var constantSendEmailManualOff = 5;

var emailBodyHolydayStart = 'Die Anwesenheitssimulation wurde um <timestamp> gestartet, weil der Urlaub <NameOfHoliday> nun beginnt.';
var subjectHolydayStart = "Anwesenheitsimulation eingeschaltet";
var emailBodyHolydayEnd = 'Die Anwesenheitssimulation wurde um <timestamp> beendet, weil der Urlaub <NameOfHoliday> nun endet.';
var subjectHolydayEnd = "Anwesenheitsimulation ausgeschaltet";

var emailBodyGehen = 'Die Anwesenheitssimulation wurde um <timestamp> gestartet, weil die Aktion "Gehen" ausgeloest wurde.';
var subjectBodyGehen = "Anwesenheitsimulation eingeschaltet";
var emailBodyKommen = 'Die Anwesenheitssimulation wurde um <timestamp> beendet, weil die Aktion "Kommen" ausgeloest worden ist.';
var subjectBodyKommen = "Anwesenheitsimulation ausgeschaltet";

var emailBodyManualOn = 'Die Anwesenheitssimulation wurde um <timestamp> gestartet, weil sie manuell eingeschaltet wurde.';
var subjectBodyManualOn = "Anwesenheitsimulation eingeschaltet";
var emailBodyManualOff = 'Die Anwesenheitssimulation wurde um <timestamp> beendet, weil sie manuell abgeschaltet wurde.';
var subjectBodyManualOff = "Anwesenheitsimulation ausgeschaltet";

/*
 * Beim Starten prfen nach Status/serialisieren des Status
 * 
 */

function timeStamp() {
	var oDate = new Date();
	return oDate.getDate() + "." + (oDate.getMonth() + 1) + "."
			+ oDate.getFullYear() + " " + pad(oDate.getHours()) + ":"
			+ pad(oDate.getMinutes());
}

function sendEmail(fEmailType, sHoliday) {
	if (Property.getProperty("/scripts/presence-simulator/general/emailMode") != 1)
		return;
	var oDate = new Date();
	var to = Property
			.getNode('/scripts/presence-simulator/general/emailReceiver');
	if (to == null) {
		l.logln("sendEmail: kein Empfnger konfiguriert");
		return;
	}
	var body = "";
	var subject = "";
	switch (fEmailType) {
	case 0: // constantSendEmailHolidayStart
		body = emailBodyHolydayStart;
		subject = subjectHolydayStart;
		break;
	case 1: // constantSendEmailHolidayEnd
		body = emailBodyHolydayEnd;
		subject = subjectHolydayEnd;
		break;
	case 2: // constantSendEmailGehen
		body = emailBodyGehen;
		subject = subjectBodyGehen;
		break;
	case 3: // constantSendEmailKommen
		body = emailBodyKommen;
		subject = subjectBodyKommen;
		break;
	case 4: // constantSendEmailManualOn
		body = emailBodyManualOn;
		subject = subjectBodyManualOn;
		break;
	case 5: // constantSendEmailManualOff
		body = emailBodyManualOff;
		subject = subjectBodyManualOff;
		break;
	}
	body = body.replace('<timestamp>', timeStamp());
	body = body.replace('<NameOfHoliday>', sHoliday);

	subject = subject.replace('<timestamp>', timeStamp());
	subject = subject.replace('<NameOfHoliday>', sHoliday);

	l.logln("sendEmail: sende Email an: " + to.getValue() + " Subject: "
			+ subject + " Body: " + body);
	var evt = new Event("presence-simulator-mail", {
		'to' : to.getValue(),
		'body' : body,
		'subject' : subject,
		'from' : 'dSS-Anwesenheitsimulation'
	});
	evt.raise();
}

function pad(c) {
	var i = parseInt(c, 10);
	return (i < 10 ? '0' + i : c.toString());
}

function disableTimedEvents() {
	l.logln('disableTimedEvents');

	var aTimedEventsNode = Property.getNode('/scripts/timed-events/events');
	if (aTimedEventsNode != null) {
		var aTimedEventsNodes = aTimedEventsNode.getChildren();
		if (Property.getProperty('values') != null)
			Property.getProperty('values').removeChild('timed-event-ref');
		for ( var iIndex = 0; iIndex < aTimedEventsNodes.length; iIndex++) {
			// saveActualValue
			var sTimedProp = aTimedEventsNodes[iIndex];
			var sName = sTimedProp.getName();
			var bDisabled = sTimedProp.getChild('disabled').getValue();
			l.logln('TE ' + sName + ' disabled: ' + bDisabled);
			Property.setProperty('values/timed-event-ref/' + sName, bDisabled);
			Property.setFlag('values/timed-event-ref/' + sName, 'ARCHIVE', true);
			// setValue
			sTimedProp.getChild('disabled').setValue(true);
		}
	} else {
	    var aTimedEventsNodeNew = Property.getNode('/scripts/timed-events/entries');
	    	    
	    if (aTimedEventsNodeNew != null) {
	        var aTimedEventsNodes = aTimedEventsNodeNew.getChildren();
	        if (Property.getProperty('values') != null)
	            Property.getProperty('values').removeChild('timed-event-ref');

            var oneID = null;
	        for ( var iIndex = 0; iIndex < aTimedEventsNodes.length; iIndex++) {
	            // saveActualValue
	            var sTimedProp = aTimedEventsNodes[iIndex];
	            var sName = sTimedProp.getName();
	            var bDisabled = sTimedProp.getChild('conditions/enabled').getValue();
	            l.logln('TE NEW ' + sName + ' enabled: ' + bDisabled);
	            Property.setProperty('values/timed-event-ref/' + sName, bDisabled);
	            Property.setFlag('values/timed-event-ref/' + sName, 'ARCHIVE', true);
	            // setValue
	            sTimedProp.getChild('conditions/enabled').setValue(false);
                oneID = sName;
	        }

            if (oneID != null) {
                var evt = new Event("timed-events.config", {actions: 'disable', id: oneID});
                evt.raise();
            }
	    }
	    
	}
	Property.store();
}

function enableTimedEvents() {
	l.logln('enableTimedEvents');

	var aTimedEventsNode = Property.getNode('/scripts/timed-events/events');
	if (aTimedEventsNode != null) {
		var aTimedEventsNodes = aTimedEventsNode.getChildren();
		for ( var iIndex = 0; iIndex < aTimedEventsNodes.length; iIndex++) {
			// saveActualValue
			// setValue
			var sTimedProp = aTimedEventsNodes[iIndex];
			var sName = sTimedProp.getName();
			if (Property.getProperty('values/timed-event-ref/' + sName) != null) {
				var bDisabled = Property.getProperty('values/timed-event-ref/'
						+ sName);
				l.logln('TE ' + sName + ' disabled: ' + bDisabled);
				Property.setProperty('/scripts/timed-events/events/' + sName
						+ '/disabled', bDisabled);
			}
		}
		if (Property.getProperty('values') != null)
			Property.getProperty('values').removeChild('timed-event-ref');
	} else {
	    var aTimedEventsNodeNew = Property.getNode('/scripts/timed-events/entries');        
        if (aTimedEventsNodeNew != null) {
            var aTimedEventsNodes = aTimedEventsNodeNew.getChildren();
            var oneID = null;
            for ( var iIndex = 0; iIndex < aTimedEventsNodes.length; iIndex++) {
                // saveActualValue
                // setValue
                var sTimedProp = aTimedEventsNodes[iIndex];
                var sName = sTimedProp.getName();
                if (Property.getProperty('values/timed-event-ref/' + sName) != null) {
                    var bDisabled = Property.getProperty('values/timed-event-ref/' + sName);
                    l.logln('TE NEW ' + sName + ' enabled: ' + bDisabled);
                    Property.setProperty('/scripts/timed-events/entries/' + sName
                            + '/conditions/enabled', bDisabled);
                }
                oneID = sName;
            }
            if (Property.getProperty('values') != null)
                Property.getProperty('values').removeChild('timed-event-ref');

            if (oneID != null) {
                var evt = new Event("timed-events.config", {actions: 'enable', id: oneID});
                evt.raise();
            }
        }
	}
	Property.store();
}

function scheduleHolidayCheck() {
	l.logln('scheduleHolidayCheck');
	var aOldNotes = Property.getNode('dynamic/holidaycheck');
	if (aOldNotes != null) {
		l.logln('scheduleHolidayCheck - remove old');
		var queue = aOldNotes.getChildren();

		for ( var i = 0; i < queue.length; ++i) {
			var propNode = Property
					.getNode('/system/EventInterpreter/ScheduledEvents/'
							+ queue[i].getValue());
			if (propNode) {
				propNode.getParent().removeChild(propNode);
			}
			l.logln('scheduleHolidayCheck - remove old #' + i);
		}
	}
	var aOldNotes = Property.getNode('dynamic');
	if (aOldNotes != null)
		aOldNotes.removeChild('holidaycheck');

	l.logln('scheduleHolidayCheck - adding');
	var sRRule = "FREQ=DAILY;COUNT=1";
	var holidayBase = Property.getNode('values/holiday');
	if (holidayBase == null)
		return;
	var holidayNodes = holidayBase.getChildren();
	for ( var iIndex = 0; iIndex < holidayNodes.length; iIndex++) {

		// holiday start
		var iVon = parseInt(holidayNodes[iIndex].getChild('von').getValue(), 10);
		var d = new Date();
		d.setTime(iVon * 1000);
		var iCalStartTime = d.getFullYear() + pad(d.getMonth() + 1)
				+ pad(d.getDate()) + 'T' + pad(d.getHours())
				+ pad(d.getMinutes()) + pad(d.getSeconds());
		var oParameter = {
			iCalRRule : sRRule,
			iCalStartTTime : iCalStartTime,
			actions : 'checkHoliday'
		};
		var timerEvent = new TimedICalEvent('presence-simulator',
				iCalStartTime, sRRule, {
					actions : 'checkHoliday'
				});
		l.logln('recheck holiday: - ' + iCalStartTime);
		Property.setProperty('dynamic/holidaycheck/' + iIndex + '_von',
				timerEvent.raise());

		// holiday start before events
		var aTimedEventsNode = Property.getNode('values/actions');
		if (aTimedEventsNode != null) {
			var aTimedEventsNodes = aTimedEventsNode.getChildren();
			for ( var lIndex = 0; lIndex < aTimedEventsNodes.length; lIndex++) {
				var oTimedNode = aTimedEventsNodes[lIndex];
				if (oTimedNode.getChild("holidayStart") != null) {
					var iTimeDiv = oTimedNode.getChild("holidayStart")
							.getValue();
					if (iTimeDiv < 0) {
						l.logln('scheduleHolidayCheck - schedule action '
								+ oTimedNode.getChild('name').getValue());
						var oArray = [];
						for ( var jIndex = 0; jIndex < oTimedNode.getChild(
								'actions').getChildren().length; jIndex++) {
							l.logln('scheduleHolidayCheck - getSubaction #'
									+ jIndex);
							var oSubNode = oTimedNode.getChild('actions')
									.getChildren()[jIndex];
							var oObject = {};
							oObject.index = jIndex;
							oObject.delay = oSubNode.getChild('delay')
									.getValue() * 60;
							oArray.push(oObject)

						}
						oArray.sort(function(a, b) {
							return ((a.delay < b.delay) ? -1 : 1);
						});
						for ( var jIndex = 0; jIndex < oArray.length; jIndex++) {
							var iActDelay = oArray[jIndex].delay + 1;
							for ( var kIndex = jIndex + 1; kIndex < oArray.length; kIndex++) {
								if (oArray[kIndex].delay == oArray[jIndex].delay) {
									l.logln('scheduleHolidayCheck - Subaction '
											+ jIndex + ' war gleichzeitig mit '
											+ kIndex);
									oArray[kIndex].delay = iActDelay;
									iActDelay++;
								}
							}
						}

						for ( var jIndex = 0; jIndex < oArray.length; jIndex++) {
							var oObject = oArray[jIndex];

							var fWithDifference = 0;

							var timeValue = iVon + parseInt(iTimeDiv, 10);
							l.logln("scheduleHolidayCheck - Delay is "
									+ oObject.delay);

							timeValue += parseInt(oObject.delay, 10);

							if (oTimedNode.getChild('maxdiv') != null)
								if (oTimedNode.getChild('maxdiv').getValue() != 'undefined')
									fWithDifference = oTimedNode.getChild(
											'maxdiv').getValue() / 2;

							l.logln('scheduleHolidayCheck - difference is '
									+ fWithDifference);
							l.logln("scheduleHolidayCheck - timeValue is "
									+ (timeValue))
							l.logln("scheduleHolidayCheck - time is "
									+ ((timeValue - fWithDifference)));
							d.setTime((timeValue - fWithDifference) * 1000);

							var iCalStartTime = d.getFullYear()
									+ pad(d.getMonth() + 1) + pad(d.getDate())
									+ 'T' + pad(d.getHours())
									+ pad(d.getMinutes()) + pad(d.getSeconds());

							l.logln('scheduleHolidayCheck - insert start : '
									+ iCalStartTime + ' rrule: ' + sRRule);

							var timerEvent = new TimedICalEvent(
									'presence-simulator',
									iCalStartTime,
									sRRule,
									{
										actions : (fWithDifference != 0) ? 'variable-timed-event'
												: 'execute-timed-event',
										id : oTimedNode.getChild('id')
												.getValue(),
										index : oObject.index,
										override : 1
									});
							Property.setProperty('dynamic/holidaycheck/'
									+ oTimedNode.getChild('id').getValue()
									+ '_' + oObject.index, timerEvent.raise());
						}
					}
				}
			}
		}

		// holiday ende
		var iBis = parseInt(holidayNodes[iIndex].getChild('bis').getValue(), 10);
		d.setTime(iBis * 1000);
		iCalStartTime = d.getFullYear() + pad(d.getMonth() + 1)
				+ pad(d.getDate()) + 'T' + pad(d.getHours())
				+ pad(d.getMinutes()) + pad(d.getSeconds());

		oParameter = {
			iCalRRule : sRRule,
			iCalStartTTime : iCalStartTime,
			actions : 'checkHoliday'
		};

		timerEvent = new TimedICalEvent('presence-simulator', iCalStartTime,
				sRRule, {
					actions : 'checkHoliday'
				});

		l.logln('recheck holiday: - ' + iCalStartTime);

		Property.setProperty('dynamic/holidaycheck/' + iIndex + '_bis',
				timerEvent.raise());

		// holiday ende before events

		var aTimedEventsNode = Property.getNode('values/actions');
		if (aTimedEventsNode != null) {
			var aTimedEventsNodes = aTimedEventsNode.getChildren();
			for ( var lIndex = 0; lIndex < aTimedEventsNodes.length; lIndex++) {
				var oTimedNode = aTimedEventsNodes[lIndex];
				if (oTimedNode.getChild("holidayEnd") != null) {
					var iTimeDiv = oTimedNode.getChild("holidayEnd").getValue();
					if (iTimeDiv < 0) {
						l.logln('scheduleHolidayCheck - schedule action '
								+ oTimedNode.getChild('name').getValue());

						var oArray = [];
						for ( var jIndex = 0; jIndex < oTimedNode.getChild(
								'actions').getChildren().length; jIndex++) {
							l.logln('scheduleHolidayCheck - getSubaction #'
									+ jIndex);
							var oSubNode = oTimedNode.getChild('actions')
									.getChildren()[jIndex];
							var oObject = {};
							oObject.index = jIndex;
							oObject.delay = oSubNode.getChild('delay')
									.getValue() * 60;
							oArray.push(oObject)

						}
						oArray.sort(function(a, b) {
							return ((a.delay < b.delay) ? -1 : 1);
						});
						for ( var jIndex = 0; jIndex < oArray.length; jIndex++) {
							var iActDelay = oArray[jIndex].delay + 1;
							for ( var kIndex = jIndex + 1; kIndex < oArray.length; kIndex++) {
								if (oArray[kIndex].delay == oArray[jIndex].delay) {
									l.logln('scheduleHolidayCheck - Subaction '
											+ jIndex + ' war gleichzeitig mit '
											+ kIndex);
									oArray[kIndex].delay = iActDelay;
									iActDelay++;
								}
							}
						}

						for ( var jIndex = 0; jIndex < oArray.length; jIndex++) {
							var oObject = oArray[jIndex];
							var d = new Date();

							var fWithDifference = 0;

							var timeValue = iBis + parseInt(iTimeDiv, 10);
							l.logln("scheduleHolidayCheck - Delay is "
									+ oObject.delay);

							timeValue += parseInt(oObject.delay, 10);

							if (oTimedNode.getChild('maxdiv') != null)
								if (oTimedNode.getChild('maxdiv').getValue() != 'undefined')
									fWithDifference = oTimedNode.getChild(
											'maxdiv').getValue() / 2;

							l.logln('scheduleHolidayCheck - difference is '
									+ fWithDifference);
							l.logln("scheduleHolidayCheck - timeValue is "
									+ typeof (timeValue))
							d.setTime((timeValue - fWithDifference) * 1000);

							var iCalStartTime = d.getFullYear()
									+ pad(d.getMonth() + 1) + pad(d.getDate())
									+ 'T' + pad(d.getHours())
									+ pad(d.getMinutes()) + pad(d.getSeconds());

							l.logln('scheduleHolidayCheck - insert start : '
									+ iCalStartTime + ' rrule: ' + sRRule);

							var timerEvent = new TimedICalEvent(
									'presence-simulator',
									iCalStartTime,
									sRRule,
									{
										actions : (fWithDifference != 0) ? 'variable-timed-event'
												: 'execute-timed-event',
										id : oTimedNode.getChild('id')
												.getValue(),
										index : oObject.index,
										override : 1
									});
							Property.setProperty('dynamic/holidaycheck/'
									+ oTimedNode.getChild('id').getValue()
									+ '_' + oObject.index, timerEvent.raise());
						}
					}
				}
			}
		}

	}
}

function checkNow(iCheckScene) {

	var autoMode = Property.getNode('general/autoMode');
	if (autoMode != null) {
		if (autoMode.getValue() != constantAutoModeOnlyHoliday)
			if (autoMode.getValue() != constantAutoModeOnGehen)
				return;
	}
	var fActive = false;
	var iEmailType = constantSendEmailHolidayEnd ;
	if (iCheckScene!=null)
		iEmailType=iCheckScene;			
	var sHolidayName = "";
	var holidayBase = Property.getNode('values/holiday');
	if (holidayBase != null) {
		var holidayNodes = holidayBase.getChildren();
		var lNow = Math.floor(((new Date()).getTime()) / 1000);
		l.logln("lNow " + lNow);
		for ( var iIndex = 0; iIndex < holidayNodes.length; iIndex++) {
			var iVon = parseInt(
					holidayNodes[iIndex].getChild('von').getValue(), 10);
			var iBis = parseInt(
					holidayNodes[iIndex].getChild('bis').getValue(), 10);
			if (iVon <= lNow)
				if (lNow < iBis) {
					fActive = true;
					iEmailType = constantSendEmailHolidayStart ;
					sHolidayName = holidayNodes[iIndex].getChild('name')
							.getValue()
				}
		}
	}
	setPresenceState(fActive, iEmailType ,sHolidayName);
}

function getPresenceState() {
	var autoMode = Property.getNode('general/autoMode');
	var propValue = false;
	var activeProperty = Property.getNode('general/active');
	if (activeProperty)
		propValue = activeProperty.getValue();

	if (autoMode != null) {
		if (autoMode.getValue() == constantAutoModeManualOff) {
			if (propValue == true)
				setPresenceState(false,constantSendEmailManualOff );
			return false;
		}
		if (autoMode.getValue() == constantAutoModeManualOn) {
			if (propValue == false)
				setPresenceState(true,constantSendEmailManualOn );
			return true;
		}
	}

	return propValue;
}

function setPresenceState(fOn, emailType ,sHoliday) {
	l.logln("setPresenceState " + fOn);
	var activeProperty = Property.getNode('general/active');
	if (activeProperty)
		if (activeProperty.getValue() == fOn)
			return;
	Property.setProperty('general/active', fOn);
	Property.setFlag('general/active', "ARCHIVE", true);
	Property.store();
	if (fOn) {
		sendEmail(emailType, sHoliday);
		disableTimedEvents();
		queueEventsHolidayStartAfter();
	} else {
		sendEmail(emailType , sHoliday);
		enableTimedEvents();
		queueEventsHolidayEndAfter();
	}
}

function queueEventsHolidayStartAfter() {
	l.logln('queueEventsHolidayStartAfter');
	// holiday start before events
	var aTimedEventsNode = Property.getNode('values/actions');
	if (aTimedEventsNode != null) {
		var aTimedEventsNodes = aTimedEventsNode.getChildren();
		for ( var lIndex = 0; lIndex < aTimedEventsNodes.length; lIndex++) {
			var oTimedNode = aTimedEventsNodes[lIndex];
			if (oTimedNode.getChild("holidayStart") != null) {
				var iTimeDiv = oTimedNode.getChild("holidayStart").getValue();
				if (iTimeDiv > 0) {
					l.logln('queueEventsHolidayStartAfter - schedule action '
							+ oTimedNode.getChild('name').getValue());
					var oArray = [];
					for ( var jIndex = 0; jIndex < oTimedNode.getChild(
							'actions').getChildren().length; jIndex++) {
						l.logln('queueEventsHolidayStartAfter - getSubaction #'
								+ jIndex);
						var oSubNode = oTimedNode.getChild('actions')
								.getChildren()[jIndex];
						var oObject = {};
						oObject.index = jIndex;
						oObject.delay = oSubNode.getChild('delay').getValue() * 60;
						oArray.push(oObject)

					}
					oArray.sort(function(a, b) {
						return ((a.delay < b.delay) ? -1 : 1);
					});
					for ( var jIndex = 0; jIndex < oArray.length; jIndex++) {
						var iActDelay = oArray[jIndex].delay + 1;
						for ( var kIndex = jIndex + 1; kIndex < oArray.length; kIndex++) {
							if (oArray[kIndex].delay == oArray[jIndex].delay) {
								l
										.logln('queueEventsHolidayStartAfter - Subaction '
												+ jIndex
												+ ' war gleichzeitig mit '
												+ kIndex);
								oArray[kIndex].delay = iActDelay;
								iActDelay++;
							}
						}
					}

					for ( var jIndex = 0; jIndex < oArray.length; jIndex++) {
						var oObject = oArray[jIndex];

						var fWithDifference = 0;

						var timeValue = parseInt(iTimeDiv, 10);
						l.logln("queueEventsHolidayStartAfter - Delay is "
								+ oObject.delay);

						timeValue += parseInt(oObject.delay, 10);

						if (oTimedNode.getChild('maxdiv') != null)
							if (oTimedNode.getChild('maxdiv').getValue() != 'undefined')
								fWithDifference = oTimedNode.getChild('maxdiv')
										.getValue() / 2;

						l.logln('queueEventsHolidayStartAfter - difference is '
								+ fWithDifference);
						l.logln("queueEventsHolidayStartAfter - timeValue is "
								+ (timeValue))
						l.logln("queueEventsHolidayStartAfter - time is "
								+ ((timeValue - fWithDifference)));

						var iDiffSeconds = timeValue - fWithDifference;
						if (iDiffSeconds < 1)
							iDiffSeconds = 1;
						l.logln("queueEventsHolidayStartAfter - final is "
								+ iDiffSeconds);
						var newEvent = new TimedEvent(
								'presence-simulator',
								'+' + iDiffSeconds,
								{
									actions : (fWithDifference != 0) ? 'variable-timed-event'
											: 'execute-timed-event',
									id : oTimedNode.getChild('id').getValue(),
									index : oObject.index,
									override : 1
								});
						l.logln("queueEventsHolidayStartAfter - event: "
								+ newEvent);
						Property.setProperty('dynamic/holidaycheck_t/'
								+ oTimedNode.getChild('id').getValue() + '_'
								+ oObject.index, newEvent.raise());
						l.logln("queueEventsHolidayStartAfter - event raised: "
								+ newEvent);
					}
				}
			}
		}
	}

}

function queueEventsHolidayEndAfter() {
	l.logln('queueEventsHolidayEndAfter');
	var aTimedEventsNode = Property.getNode('values/actions');
	if (aTimedEventsNode != null) {
		var aTimedEventsNodes = aTimedEventsNode.getChildren();
		for ( var lIndex = 0; lIndex < aTimedEventsNodes.length; lIndex++) {
			var oTimedNode = aTimedEventsNodes[lIndex];
			if (oTimedNode.getChild("holidayEnd") != null) {
				var iTimeDiv = oTimedNode.getChild("holidayEnd").getValue();
				if (iTimeDiv > 0) {
					l.logln('queueEventsHolidayEndAfter - schedule action '
							+ oTimedNode.getChild('name').getValue());
					var oArray = [];
					for ( var jIndex = 0; jIndex < oTimedNode.getChild(
							'actions').getChildren().length; jIndex++) {
						l.logln('queueEventsHolidayEndAfter - getSubaction #'
								+ jIndex);
						var oSubNode = oTimedNode.getChild('actions')
								.getChildren()[jIndex];
						var oObject = {};
						oObject.index = jIndex;
						oObject.delay = oSubNode.getChild('delay').getValue() * 60;
						oArray.push(oObject)

					}
					oArray.sort(function(a, b) {
						return ((a.delay < b.delay) ? -1 : 1);
					});
					for ( var jIndex = 0; jIndex < oArray.length; jIndex++) {
						var iActDelay = oArray[jIndex].delay + 1;
						for ( var kIndex = jIndex + 1; kIndex < oArray.length; kIndex++) {
							if (oArray[kIndex].delay == oArray[jIndex].delay) {
								l
										.logln('queueEventsHolidayEndAfter - Subaction '
												+ jIndex
												+ ' war gleichzeitig mit '
												+ kIndex);
								oArray[kIndex].delay = iActDelay;
								iActDelay++;
							}
						}
					}

					for ( var jIndex = 0; jIndex < oArray.length; jIndex++) {
						var oObject = oArray[jIndex];

						var fWithDifference = 0;

						var timeValue = parseInt(iTimeDiv, 10);
						l.logln("queueEventsHolidayEndAfter - Delay is "
								+ oObject.delay);

						timeValue += parseInt(oObject.delay, 10);

						if (oTimedNode.getChild('maxdiv') != null)
							if (oTimedNode.getChild('maxdiv').getValue() != 'undefined')
								fWithDifference = oTimedNode.getChild('maxdiv')
										.getValue() / 2;

						l.logln('queueEventsHolidayEndAfter - difference is '
								+ fWithDifference);
						l.logln("queueEventsHolidayEndAfter - timeValue is "
								+ (timeValue))
						l.logln("queueEventsHolidayEndAfter - time is "
								+ ((timeValue - fWithDifference)));

						var iDiffSeconds = timeValue - fWithDifference;
						if (iDiffSeconds < 1)
							iDiffSeconds = 1;

						var newEvent = new TimedEvent(
								'presence-simulator',
								'+' + iDiffSeconds,
								{
									actions : (fWithDifference != 0) ? 'variable-timed-event'
											: 'execute-timed-event',
									id : oTimedNode.getChild('id').getValue(),
									index : oObject.index,
									override : 1
								});
						Property.setProperty('dynamic/holidaycheck_t/'
								+ oTimedNode.getChild('id').getValue() + '_'
								+ oObject.index, newEvent.raise());

					}
				}
			}
		}
	}

}

function deleteTimedEvents() {
	l.logln('deleteTimedEvents');
	var aOldNotes = Property.getNode('dynamic/timedEvents');
	if (aOldNotes != null) {
		l.logln('deleteTimedEvents - remove old');
		var queue = aOldNotes.getChildren();

		for ( var i = 0; i < queue.length; ++i) {
			var propNode = Property
					.getNode('/system/EventInterpreter/ScheduledEvents/'
							+ queue[i].getValue());
			if (propNode) {
				propNode.getParent().removeChild(propNode);
			}
			l.logln('deleteTimedEvents - remove old #' + i);
		}
	}
	var aOldNotes = Property.getNode('dynamic');
	if (aOldNotes != null)
		aOldNotes.removeChild('timedEvents');
}

function queueTimedEvents() {
	l.logln('queueTimedEvents');
	var parentEvents = Property.getNode('values/actions');
	if (parentEvents != null) {
		var aEvents = parentEvents.getChildren();
		for ( var iIndex = 0; iIndex < aEvents.length; iIndex++) {
			var oEvent = aEvents[iIndex];
			l.logln('queueTimedEvents - adding #'
					+ oEvent.getChild('id').getValue());
			if (oEvent.getChild('time') != null) // nur statische Events hier
			{
				l.logln('queueTimedEvents - it has a fixed time');
				var oRecChildren = oEvent.getChild('recurrence').getChildren();
				var sRRule = "";
				if (oRecChildren != null) {
					for ( var jIndex = 0; jIndex < oRecChildren.length; jIndex++)
						if (jIndex != 0)
							sRRule += "," + oRecChildren[jIndex].getValue();
						else
							sRRule = "FREQ=WEEKLY;BYDAY="
									+ oRecChildren[jIndex].getValue();
				}
				if (sRRule != "") {
					var oArray = [];
					for ( var jIndex = 0; jIndex < oEvent.getChild('actions')
							.getChildren().length; jIndex++) {
						l.logln('queueTimedEvents - getSubaction #' + jIndex);
						var oSubNode = oEvent.getChild('actions').getChildren()[jIndex];
						var oObject = {};
						oObject.index = jIndex;
						oObject.delay = oSubNode.getChild('delay').getValue() * 60;
						oArray.push(oObject)

					}
					oArray.sort(function(a, b) {
						return ((a.delay < b.delay) ? -1 : 1);
					});
					for ( var jIndex = 0; jIndex < oArray.length; jIndex++) {
						var iActDelay = oArray[jIndex].delay + 1;
						for ( var kIndex = jIndex + 1; kIndex < oArray.length; kIndex++) {
							if (oArray[kIndex].delay == oArray[jIndex].delay) {
								l.logln('queueTimedEvents - Subaction '
										+ jIndex + ' war gleichzeitig mit '
										+ kIndex);
								oArray[kIndex].delay = iActDelay;
								iActDelay++;
							}
						}
					}
					for ( var jIndex = 0; jIndex < oArray.length; jIndex++) {
						var oObject = oArray[jIndex];
						var d = new Date();
						var dold = new Date();
						dold
								.setTime(dold.getTime()
										- (1000 * 60 * 60 * 24 * 7));

						var fWithDifference = 0;

						var timeValue = parseInt(oEvent.getChild('time')
								.getValue(), 10);
						l.logln("queueTimedEvents - Delay is " + oObject.delay);

						timeValue += oObject.delay;

						if (oEvent.getChild('maxdiv') != null)
							if (oEvent.getChild('maxdiv').getValue() != 'undefined')
								fWithDifference = oEvent.getChild('maxdiv')
										.getValue() / 2;

						l.logln('queueTimedEvents - difference is '
								+ fWithDifference);
						l.logln("queueTimedEvents - timeValue is "
								+ typeof (timeValue))
						d.setTime((timeValue - fWithDifference) * 1000);

						var iCalStartTime = dold.getFullYear()
								+ pad(dold.getMonth() + 1)
								+ pad(dold.getDate()) + 'T' + pad(d.getHours())
								+ pad(d.getMinutes()) + pad(d.getSeconds());

						l.logln('queueTimedEvents - insert start : '
								+ iCalStartTime + ' rrule: ' + sRRule);

						var timerEvent = new TimedICalEvent(
								'presence-simulator',
								iCalStartTime,
								sRRule,
								{
									actions : (fWithDifference != 0) ? 'variable-timed-event'
											: 'execute-timed-event',
									id : oEvent.getChild('id').getValue(),
									index : oObject.index
								});
						Property.setProperty('dynamic/timedEvents/'
								+ oEvent.getChild('id').getValue() + '_'
								+ oObject.index, timerEvent.raise());
					}
				}
			} else {
				l.logln('queueTimedEvents - it has not a fixed time');
			}
		}
	}
}

function executeEvent() {
	l.logln('executeEvent');
	if (raisedEvent.parameter.index == null)
		return;
	var oNode = Property.getNode('values/actions/' + raisedEvent.parameter.id);
	if (oNode == null)
		return;
	if (oNode.getChild('disabled') != null) {
		if (oNode.getChild('disabled').getValue() != null) {
			if (oNode.getChild('disabled').getValue() == true) {
				return;
			}
		}
	}
	var autoMode = Property.getNode('general/autoMode');
	if (autoMode == null)
		return;
	if (autoMode.getValue() == constantAutoModeManualOff)
		return;
	if (getPresenceState() == false)
		if (raisedEvent.parameter.override == null)
			return;
	if (oNode.getChild('actions') == null)
		return;
	if (raisedEvent.parameter.index >= oNode.getChild('actions').getChildren().length)
		return;
	var oSubNode = oNode.getChild('actions').getChildren()[raisedEvent.parameter.index];

	var target = getDevices();
	if (target != null)
		target = target.byZone(oSubNode.getChild('zone').getValue());
	if (target != null)
		target = target.byGroup(oSubNode.getChild('group').getValue());
	if (target != null)
		target = target.byPresence(true);
	if (target != null) {
		l.logln("Fuehre aus: node " + raisedEvent.parameter.id + " index "
				+ raisedEvent.parameter.index + " -> Zone "
				+ oSubNode.getChild('zone').getValue() + " Group "
				+ oSubNode.getChild('group').getValue() + " Scene "
				+ oSubNode.getChild('scene').getValue());
		target.callScene(oSubNode.getChild('scene').getValue());
		return;
	}
	l.logln("Fuehre NICHT AUS (weil nicht da): node "
			+ raisedEvent.parameter.id + " index "
			+ raisedEvent.parameter.index + " -> Zone "
			+ oSubNode.getChild('zone').getValue() + " Group "
			+ oSubNode.getChild('group').getValue() + " Scene "
			+ oSubNode.getChild('scene').getValue());
}

function setVariableTimedEvent() {
	l.logln('setVariableTimedEvent');
	var oNode = Property.getNode('values/actions/' + raisedEvent.parameter.id);
	if (oNode != null) {
		if (oNode.getChild('maxdiv') != null) {
			if (oNode.getChild('maxdiv').getValue() == 0) {
				executeEvent();
				return;
			}
			var iDiffSeconds = Math.round(oNode.getChild('maxdiv').getValue()
					* Math.random());
			l.logln('setVariableTimedEvent - reschedule with random: '
					+ iDiffSeconds);
			var newEvent = new TimedEvent('presence-simulator', '+'
					+ iDiffSeconds, {
				actions : 'execute-timed-event',
				id : raisedEvent.parameter.id,
				index : raisedEvent.parameter.index
			});
			Property.setProperty('dynamic/timedEvents/r_'
					+ raisedEvent.parameter.id + '_'
					+ raisedEvent.parameter.index, newEvent.raise());
		}
	}
}

function deleteSunriseEvents() {
	l.logln('deleteSunriseEvents');
	var aOldNotes = Property.getNode('dynamic/timedEvents_suntime');
	if (aOldNotes != null) {
		l.logln('deleteTimedEvents - remove old');
		var queue = aOldNotes.getChildren();

		for ( var i = 0; i < queue.length; ++i) {
			var propNode = Property
					.getNode('/system/EventInterpreter/ScheduledEvents/'
							+ queue[i].getValue());
			if (propNode) {
				propNode.getParent().removeChild(propNode);
			}
			l.logln('deleteTimedEvents - remove old #' + i);
		}
	}
	var aOldNotes = Property.getNode('dynamic');
	if (aOldNotes != null)
		aOldNotes.removeChild('timedEvents_suntime');
}

function scheduleSunTimedEvents() {
	deleteSunriseEvents();
	l.logln('scheduleSunTimedEvents');
	var iSunriseSecondsSinceMidnight = 0;
	var iSunsetSecondsSinceMidnight = 0;
	var sunriseNode = Property.getNode('/config/geodata/sunrise');
	if (sunriseNode == null) {
		l.logln('scheduleSunTimedEvents - no sunrise Infomation');
		return;
	}
	var sString = sunriseNode.getValue();
	var sArray = sString.split(':');
	if (sArray.length != 3) {
		l.logln('scheduleSunTimedEvents - no sunrise Infomation');
		return;
	}
	iSunriseSecondsSinceMidnight = parseInt(sArray[2], 10);
	iSunriseSecondsSinceMidnight += parseInt(sArray[1], 10) * 60;
	iSunriseSecondsSinceMidnight += parseInt(sArray[0], 10) * 60 * 60;
	l.logln('scheduleSunTimedEvents - sunrise at ' + sString
			+ '; seconds since Midnight ' + iSunriseSecondsSinceMidnight);
	var sunsetNode = Property.getNode('/config/geodata/sunset');
	if (sunsetNode == null) {
		l.logln('scheduleSunTimedEvents - no sunset Infomation');
		return;
	}
	sString = sunsetNode.getValue();
	sArray = sString.split(':');
	if (sArray.length != 3) {
		l.logln('scheduleSunTimedEvents - no sunset Infomation');
		return;
	}
	iSunsetSecondsSinceMidnight = parseInt(sArray[2], 10);
	iSunsetSecondsSinceMidnight += parseInt(sArray[1], 10) * 60;
	iSunsetSecondsSinceMidnight += parseInt(sArray[0], 10) * 60 * 60;
	l.logln('scheduleSunTimedEvents - sunset at ' + sString
			+ '; seconds since Midnight ' + iSunsetSecondsSinceMidnight);

	var parentEvents = Property.getNode('values/actions');
	if (parentEvents != null) {
		var aEvents = parentEvents.getChildren();
		for ( var iIndex = 0; iIndex < aEvents.length; iIndex++) {
			var oEvent = aEvents[iIndex];
			l.logln('scheduleSunTimedEvents - adding #'
					+ oEvent.getChild('id').getValue());
			var iOffset = null;
			if (oEvent.getChild('sunset') != null) // sunset Events
			{
				l.logln('scheduleSunTimedEvents - sunset Event');
				iOffset = iSunsetSecondsSinceMidnight
						+ parseInt(oEvent.getChild('sunset').getValue(), 10);
			}
			if (oEvent.getChild('sunrise') != null) // sunrise Events
			{
				l.logln('scheduleSunTimedEvents - sunrise Event');
				iOffset = iSunriseSecondsSinceMidnight
						+ parseInt(oEvent.getChild('sunrise').getValue(), 10);
			}
			if (iOffset != null) {

				var oRecChildren = oEvent.getChild('recurrence').getChildren();
				var sRRule = "";
				if (oRecChildren != null) {
					for ( var jIndex = 0; jIndex < oRecChildren.length; jIndex++)
						if (jIndex != 0)
							sRRule += "," + oRecChildren[jIndex].getValue();
						else
							sRRule = "FREQ=WEEKLY;COUNT=1;BYDAY="
									+ oRecChildren[jIndex].getValue();
				}

				if (sRRule != "") {
					var oArray = [];
					for ( var jIndex = 0; jIndex < oEvent.getChild('actions')
							.getChildren().length; jIndex++) {
						l.logln('scheduleSunTimedEvents - getSubaction #'
								+ jIndex);
						var oSubNode = oEvent.getChild('actions').getChildren()[jIndex];
						var oObject = {};
						oObject.index = jIndex;
						oObject.delay = oSubNode.getChild('delay').getValue() * 60;
						oArray.push(oObject)

					}
					oArray.sort(function(a, b) {
						return ((a.delay < b.delay) ? -1 : 1);
					});
					for ( var jIndex = 0; jIndex < oArray.length; jIndex++) {
						var iActDelay = oArray[jIndex].delay + 1;
						for ( var kIndex = jIndex + 1; kIndex < oArray.length; kIndex++) {
							if (oArray[kIndex].delay == oArray[jIndex].delay) {
								l.logln('scheduleSunTimedEvents - Subaction '
										+ jIndex + ' war gleichzeitig mit '
										+ kIndex);
								oArray[kIndex].delay = iActDelay;
								iActDelay++;
							}
						}
					}
					var fWithDifference = 0;
					if (oEvent.getChild('maxdiv') != null)
						if (oEvent.getChild('maxdiv').getValue() != 'undefined') {
							fWithDifference = parseInt(''
									+ oEvent.getChild('maxdiv').getValue(), 10) / 2;
							iOffset -= fWithDifference;
						}
					l.logln('scheduleSunTimedEvents - difference is '
							+ fWithDifference);

					for ( var jIndex = 0; jIndex < oArray.length; jIndex++) {
						var oObject = oArray[jIndex];
						l.logln("scheduleSunTimedEvents - Delay is "
								+ oObject.delay);

						var d = new Date();
						d.setTime(d.getTime() - (1000 * 60 * 60 * 24 * 7));
						var iCalStartTime = d.getFullYear()
								+ pad(d.getMonth() + 1)
								+ pad(d.getDate())
								+ 'T'
								+ pad(Math
										.floor((iOffset + oObject.delay) / 3600))
								+ pad(Math
										.floor(((iOffset + oObject.delay) / 60) % 60))
								+ pad((iOffset + oObject.delay) % 60);

						l.logln('scheduleSunTimedEvents - insert start : '
								+ iCalStartTime + ' rrule: ' + sRRule);
						var timerEvent = new TimedICalEvent(
								'presence-simulator',
								iCalStartTime,
								sRRule,
								{
									actions : (fWithDifference != 0) ? 'variable-timed-event'
											: 'execute-timed-event',
									id : oEvent.getChild('id').getValue(),
									index : oObject.index
								});
						Property.setProperty('dynamic/timedEvents_suntime/'
								+ oEvent.getChild('id').getValue(), timerEvent
								.raise());
					}
				}
			} else {
				l.logln('scheduleSunTimedEvents - it has not a sunset/sunrise');
			}
		}
	}
}

function checkScene() {
	var zone = raisedEvent.source.zoneID;
	var group = raisedEvent.source.groupID;
	var scene = raisedEvent.parameter.sceneID;
	if (zone == null)
		return;
	if (group == null)
		return;
	if (scene == null)
		return;
	var iAction = -1;
	if (zone == 0) {
		if (group == 0) {
			if (scene == 72) // gehen aktiv
			{
				iAction = 0;
			} else if (scene == 71) // kommen aktiv
			{
				iAction = 1;
			}
		}
	}

	var autoMode = Property.getNode('general/autoMode');
	if (autoMode == null)
		return;
	if (autoMode.getValue() != constantAutoModeOnGehen)
		return;
	if (iAction == -1)
		return;
	if (iAction == 0) {
		setPresenceState(true,constantSendEmailGehen);
	}
	if (iAction == 1) {
		checkNow(constantSendEmailKommen);
	}

	return;
}

if (raisedEvent.name == 'presence-simulator') {
	if (raisedEvent.parameter.actions) {
		if (raisedEvent.parameter.actions == 'starting') {
			Property.load();
		}

		getPresenceState();
		l.logln('Action is ' + raisedEvent.parameter.actions);

		if (raisedEvent.parameter.actions == 'enable-main-te') {
			enableTimedEvents();
		}

		if (raisedEvent.parameter.actions == 'disable-main-te') {
			disableTimedEvents();
		}

		if (raisedEvent.parameter.actions == 'variable-timed-event') {
			setVariableTimedEvent();
		}

		if (raisedEvent.parameter.actions == 'execute-timed-event') {
			executeEvent();
		}

		if (raisedEvent.parameter.actions == 'suntime-reschedule') {
			scheduleSunTimedEvents();
		}

		if (raisedEvent.parameter.actions == 'queue-timed-events') {
			queueTimedEvents();
		}

		if (raisedEvent.parameter.actions == 'delete-timed-events') {
			deleteTimedEvents();
		}

		if (raisedEvent.parameter.actions == 'checkDate') {
			checkNow();
		}
		if (raisedEvent.parameter.actions == 'checkHoliday') {
			checkNow();
			scheduleHolidayCheck();
		}
		if (raisedEvent.parameter.actions == 'starting') {
			checkNow();
			queueTimedEvents();
			scheduleHolidayCheck();
			scheduleSunTimedEvents();
		}
		if (raisedEvent.parameter.actions == 'save') {
			Property.store();
			checkNow();
			scheduleHolidayCheck();
			deleteTimedEvents();
			queueTimedEvents();
			scheduleSunTimedEvents();
		}
	}
}
if (raisedEvent.name == 'callScene') {
	checkScene();
}
